import { DecoratorContext, Model, Operation, Program } from "@typespec/compiler";
import { HttpOperation } from "@typespec/http";
import { ArmResourceActionDecorator, ArmResourceCollectionActionDecorator, ArmResourceCreateOrUpdateDecorator, ArmResourceDeleteDecorator, ArmResourceListDecorator, ArmResourceReadDecorator, ArmResourceUpdateDecorator } from "../generated-defs/Azure.ResourceManager.js";
export type ArmLifecycleOperationKind = "read" | "createOrUpdate" | "update" | "delete";
export type ArmOperationKind = ArmLifecycleOperationKind | "list" | "action";
export interface ArmResourceOperation extends ArmResourceOperationData {
    path: string;
    httpOperation: HttpOperation;
}
export interface ArmLifecycleOperations {
    read?: ArmResourceOperation;
    createOrUpdate?: ArmResourceOperation;
    update?: ArmResourceOperation;
    delete?: ArmResourceOperation;
}
export interface ArmResourceOperations {
    lifecycle: ArmLifecycleOperations;
    lists: {
        [key: string]: ArmResourceOperation;
    };
    actions: {
        [key: string]: ArmResourceOperation;
    };
}
interface ArmResourceOperationData {
    name: string;
    kind: ArmOperationKind;
    operation: Operation;
    operationGroup: string;
}
export declare function resolveResourceOperations(program: Program, resourceType: Model): ArmResourceOperations;
export declare const $armResourceRead: ArmResourceReadDecorator;
export declare const $armResourceCreateOrUpdate: ArmResourceCreateOrUpdateDecorator;
export declare const $armResourceUpdate: ArmResourceUpdateDecorator;
export declare const $armResourceDelete: ArmResourceDeleteDecorator;
export declare const $armResourceList: ArmResourceListDecorator;
export declare function armRenameListByOperationInternal(context: DecoratorContext, entity: Operation, resourceType: Model, parentTypeName?: string, parentFriendlyTypeName?: string, applyOperationRename?: boolean): void;
export declare const $armResourceAction: ArmResourceActionDecorator;
export declare const $armResourceCollectionAction: ArmResourceCollectionActionDecorator;
export declare function isArmCollectionAction(program: Program, target: Operation): boolean;
export {};
//# sourceMappingURL=operations.d.ts.map